//+------------------------------------------------------------------+
//|                                                   iK_tay_v01.mq4 |
//|                                                      Ivan Katsko |
//+------------------------------------------------------------------+
#property copyright "Ivan Katsko"
#property link      "" 

#property indicator_separate_window                            //    
#property indicator_buffers 7                                  //  
#property indicator_color1 DeepPink                            //   
#property indicator_color2 Purple                              //   
#property indicator_color3 Red                                 //   
#property indicator_color4 LawnGreen                           //   
#property indicator_color5 Gold                                //   
#property indicator_color6 DarkBlue                            //   
#property indicator_color7 SteelBlue                           //   
 
extern int Discret=1;                                          //  : 1 -  ; 2 -    ..
extern double Level=10;                                        //   SL/TP

int i,j,x,
    Repeat_Count=30,                                           //  
    Action_Count,                                              //  
    History,                                                   // .   
    Iteration;                                                 // .
 
static datetime New_Time;

double 
       k,                                                      // .
       Alg_Minus=-0.001,                                       // : " -   "
       Alg_Plus = 0.001,                                       // : " -  "
       Buy = 0.001,                                            //   
       Sell=-0.001,                                            //  
       Scope_Up,                                               //  
       Scope_Dn,                                               //  
       Max_Alg_Minus,                                          //    ""
       Max_Alg_Plus,                                           //    ""
       Max_Value=-0.1,
       YT_Alg_Minus,
       TP_Alg_Minus,
       SL_Alg_Minus,
       Set_Alg_Minus,
       YT_Alg_Plus,
       TP_Alg_Plus,
       SL_Alg_Plus,
       Set_Alg_Plus,
       Scope_Cl,                                               //   
       Repeat[30,3],                                           //   
       Algoritm[],                                             // : 1 - "  ", -1 - "   "
       Direction[],                                            //  : 1 - , -1 - 
       Value_TP[],                                             //  -       
       Sum_TP[],                                               //  -     
       Sum_na_TP[],                                            //  -    
       Im_Sum_TP[30],                                          //  -     
       Spread,                                                 // 
       Set_YT,                                                 //   ""
       Set_TP[],                                               //   
       Set_SL[],                                               //   
       Found_TP,                                               //    
       Found_SL,                                               //    
       Found_Scope_YT;                                         //   ""

bool 
     New_Bar=false;                                            //    

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (Discret<=0) 
     {
     Discret=1;                                                //    
     Alert ("   1");
     }
   New_Time=Time[0];                                           //   
   Spread=MarketInfo(Symbol(), MODE_SPREAD)*Point;

   SetIndexBuffer(0,Set_TP);                                   //    
   SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,2);                  //  
   SetIndexBuffer(1,Set_SL);                                   //    
   SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,1);                  //  
   SetIndexBuffer(2,Sum_TP);                                   //    
   SetIndexStyle (2,DRAW_LINE,STYLE_SOLID,2);                  //  
   SetIndexBuffer(3,Direction);                                //    
   SetIndexStyle (3,DRAW_HISTOGRAM,STYLE_SOLID,4);             //  
   SetIndexBuffer(4,Algoritm);                                 //   
   SetIndexStyle (4,DRAW_LINE,STYLE_SOLID,1);                  //  
   SetIndexBuffer(5,Value_TP);                                 //   
   SetIndexStyle (5,DRAW_HISTOGRAM,STYLE_SOLID,2);             //  

   switch (Period())                                           //  . 
      {
         case    5: History = 24; break;                       //  5-  
         case   15: History = 24; break;                       //  15- 
         case   30: History = 24; break;                       //  30- 
         case   60: History = 24; break;                       //  
         case  240: History = 30; break;                       //  4- 
         case 1440: History = 22; break;                       //  
         default: Alert("   M5  D1."); break;//   
      }

   return(0);
  }

//+------------------------------------------------------------------+
int start()
  {
   Fun_New_Bar();                                              //    

   for (int n=1; n<3; n++)                                     //    
   {
    Fun_Sum_TP(10*Point,10*Point,10*Point,Alg_Minus);          //    (  )
    
    Set_YT   =0.5*Iteration*Discret*Point;                     //   ""
    Set_SL[0]=0.5*Iteration*Discret*Point;                     //   
    Set_TP[0]=0.5*Iteration*Discret*Point;                     //   
    
    Alg_Minus=-0.25*Set_SL[0];
    Alg_Plus = 0.25*Set_TP[0];
    if (n==1) Algoritm[0]=Alg_Minus;                           //   -  "   "
    if (n==2) Algoritm[0]=Alg_Plus;                            //   -  "  "
    Repeat_Count=5+History/MathSqrt(Iteration*Discret/10);
    ArrayResize(Repeat,Repeat_Count);                          //   
    ArrayResize(Im_Sum_TP,Repeat_Count);                       //   
    ArrayInitialize(Im_Sum_TP,0);                              //   
    ArrayInitialize(Repeat,0);                                 //   
    Action_Count=0;                                            //    
    x=0;                                                       //    
    
    while (Action_Count<History/2                              //     
           || Sum_TP[0]<0)
      {                                                        //    
       Action_Count=0;                                         //    
       
       //----    ""
       for (j=0; j<Iteration-1; j++)
         {
          if (j==0) 
            {
             Max_Value=-0.1;
             Set_YT=0;
            }
          Set_YT += Discret*Point;
          if (Fun_Repeat(Set_YT,Set_SL[0],Set_TP[0])) continue;//     -  
          Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Algoritm[0]);  //    ""
          if (Max_Value<Sum_TP[0])
            {
             Max_Value=Sum_TP[0];
             Found_Scope_YT=Set_YT;
            }
         }
       Set_YT=Found_Scope_YT;                                  //    ""
       
       //----     
       for (j=0; j<Iteration-1; j++)
         {
          if (j==0) 
            {
             Max_Value=-0.1;
             Set_SL[0]=Level*Point;                            //     
            }
          Set_SL[0] += Discret*Point;
          if (Fun_Repeat(Set_YT,Set_SL[0],Set_TP[0])) continue;//     -  
          Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Algoritm[0]);  //    
          if (Max_Value<Sum_TP[0])
            {
             Max_Value=Sum_TP[0];
             Found_SL=Set_SL[0];
            }
         }
       Set_SL[0]=Found_SL;                                     //     
       
       //----     
       for (j=0; j<Iteration-1; j++)
         {
          if (j==0) 
            {
             Max_Value=-0.1;
             Set_TP[0]=Level*Point;                            //     
            }
          Set_TP[0] += Discret*Point;
          if (Fun_Repeat(Set_YT,Set_SL[0],Set_TP[0])) continue;//     -  
          Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Algoritm[0]);  //    
          if (Max_Value<Sum_TP[0])
            {
             Max_Value=Sum_TP[0];
             Found_TP=Set_TP[0];
            }
         }
       Set_TP[0]=Found_TP;                                     //     
       
       Alg_Minus=-0.25*Set_SL[0];
       Alg_Plus = 0.25*Set_TP[0];
       if (n==1) Algoritm[0]=Alg_Minus;                        //   -  "   "
       if (n==2) Algoritm[0]=Alg_Plus;                         //   -  "  "
       
       //----           
       Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Algoritm[0]);     //    
       for (j=0; j<=History-1; j++)                            //   
         if (Direction[j]!=0) Action_Count+=1;
       if (Action_Count<History/2                              //     
           || Sum_TP[0]<0)
         {
          Repeat[x,0] =Set_YT;                                 //    YT
          Repeat[x,1] =Set_SL[0];                              //    SL
          Repeat[x,2] =Set_TP[0];                              //    
          Im_Sum_TP[x]=Sum_TP[0];                              //    Sum
          x++;
         }
       if (x==Repeat_Count)                                    //    
         {                                                     //    
          Sum_TP[0]=Im_Sum_TP[ArrayMaximum(Im_Sum_TP)];
          Set_YT   =Repeat[ArrayMaximum(Im_Sum_TP),0];
          Set_SL[0]=Repeat[ArrayMaximum(Im_Sum_TP),1];
          Set_TP[0]=Repeat[ArrayMaximum(Im_Sum_TP),2];
          break;                                               //  while
         }
      }                                                        //  while
    
    if (n==1)   
      {
       Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Alg_Minus);       //  
       Max_Alg_Minus=Sum_TP[0];
       YT_Alg_Minus=Set_YT;
       TP_Alg_Minus=Set_TP[0];
       SL_Alg_Minus=Set_SL[0];
       Set_Alg_Minus=Alg_Minus;
      }
    if (n==2) 
      {
       Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Alg_Plus);        // 
       Max_Alg_Plus =Sum_TP[0];
       YT_Alg_Plus=Set_YT;
       TP_Alg_Plus=Set_TP[0];
       SL_Alg_Plus=Set_SL[0];
       Set_Alg_Plus=Alg_Plus;
      }
   }                                                           //    
   if (Max_Alg_Minus>=Max_Alg_Plus)                            //     ""
     {
      Max_Value=Max_Alg_Minus;
      Set_YT=YT_Alg_Minus;
      for (i=0; i<History/3; i++)
        {
         Set_TP[i]=TP_Alg_Minus;
         Set_SL[i]=SL_Alg_Minus;
         if (Max_Alg_Minus>0)
           Algoritm[i]=Set_Alg_Minus;
           else
           Algoritm[i]=0;
         Alg_Minus=Set_Alg_Minus;
        }
     }
      else
     {
      Max_Value=Max_Alg_Plus;
      Set_YT=YT_Alg_Plus;
      for (i=0; i<History/3; i++)
        {
         Set_TP[i]=TP_Alg_Plus;
         Set_SL[i]=SL_Alg_Plus;
         if (Max_Alg_Plus>0)
           Algoritm[i]=Set_Alg_Plus;
           else
           Algoritm[i]=0;
         Alg_Plus=Set_Alg_Plus;
        }
     }
   
   Buy = 0.5*Set_YT;
   Sell=-0.5*Set_SL[0];
   
   Fun_Sum_TP(Set_YT,Set_SL[0],Set_TP[0],Algoritm[0]);         //   
   return(0);
  }

//+------------------------------------------------------------------+
double Fun_Sum_TP(double set_YT,    // -     
                  double set_SL,double set_TP,double algoritm) 
  {
   int i,                           //  
   Count_bars;                      //    

   ArrayResize(Sum_na_TP,ArraySize(Sum_TP));
   
   Sum_TP[History]=0;               //    
   Sum_na_TP[History]=0;         
   Direction[History]=0;
   Value_TP[History-1]=0;
   
   i=Bars-1;                        //   
   if (i>History-1)                 //     ..
      i=History-1;                  // ..  .
   while(i>=0)                      //   
     {
      //----  
      Scope_Up=(High[i] -Open[i]);  //     i- 
      Scope_Dn=(Low[i]  -Open[i]);  //     i- 
      Scope_Cl=(Close[i]-Open[i]);  //     i- 
      
      //----   
      if ( Scope_Up>Iteration*Discret*Point) Iteration= (Scope_Up/Point)/Discret;
      if (-Scope_Dn>Iteration*Discret*Point) Iteration=(-Scope_Dn/Point)/Discret;
   
      //----   
      if ((Scope_Up>=(-Scope_Dn)    //      
          && Scope_Up>=set_YT       //    ""
          && algoritm==Alg_Plus)    //   "  "
          ||                        // 
          (Scope_Up<(-Scope_Dn)     //       
          && (-Scope_Dn)>=set_YT    //    ""
          && algoritm==Alg_Minus))  //   "   "
        {
         Direction[i]=Buy;          //  
        }
      if ((Scope_Up>(-Scope_Dn)     //      
          && Scope_Up>=set_YT       //    ""
          && algoritm==Alg_Minus)   //   "   "
          ||                        // 
          (Scope_Up<(-Scope_Dn)     //       
          && (-Scope_Dn)>=set_YT    //    ""
          && algoritm==Alg_Plus))   //   "  "
        {
         Direction[i]=Sell;         //  
        }
      if ((Scope_Up>=(-Scope_Dn)    //      
          && Scope_Up<set_YT)       //   ""
          ||                        // 
          (Scope_Up<=(-Scope_Dn)    //       
          && (-Scope_Dn)<set_YT))   //   ""
        {
         Direction[i]=0;            //   
        }
      //----      
      if ((Direction[i+1]==Buy             //   
          && Scope_Up>=(set_TP+Spread)     //      + 
          && (-Scope_Dn)<(set_SL-Spread))  //      - 
          ||                               // 
         (Direction[i+1]==Sell             //   
          && (-Scope_Dn)>=(set_TP+Spread)  //      + 
          && Scope_Up<(set_SL-Spread)))    //      - 
        Value_TP[i]=set_TP;                //    
      //----      
      if ((Direction[i+1]==Buy             //   
          && (-Scope_Dn)>=(set_SL-Spread)) //      - 
          ||                               // 
         (Direction[i+1]==Sell             //   
          && Scope_Up>=(set_SL-Spread)))   //      - 
        Value_TP[i]=-set_SL;               //    
      //----       
      if (Direction[i+1]==0) Value_TP[i]=0;//     -    
      if ((Direction[i+1]==Buy             //   
          && Scope_Up<(set_TP+Spread)      //      + 
          && (-Scope_Dn)<(set_SL-Spread)   //      - 
          && Scope_Cl>=0)
          ||                               // 
         (Direction[i+1]==Sell             //   
          && (-Scope_Dn)<(set_TP+Spread)   //      + 
          && Scope_Up<(set_SL-Spread)      //      - 
          && -Scope_Cl>=0))
        Value_TP[i]=MathAbs(Scope_Cl)-Spread; //      
      if ((Direction[i+1]==Buy             //   
          && Scope_Up<(set_TP+Spread)      //      + 
          && (-Scope_Dn)<(set_SL-Spread)   //      - 
          && Scope_Cl<0)
          ||                               // 
         (Direction[i+1]==Sell             //   
          && (-Scope_Dn)<(set_TP+Spread)   //      + 
          && Scope_Up<(set_SL-Spread)      //      - 
          && -Scope_Cl<0))
        Value_TP[i]=-(MathAbs(Scope_Cl)+Spread); //      
      //----     
      k=i;
      Sum_TP[i]=Sum_TP[i+1]+Value_TP[i]/((k+10)/10);
      Sum_na_TP[i]=Sum_na_TP[i+1]+Value_TP[i];
   
     i--;                                  //    
     }
   return(0);                              //  
  }
//+------------------------------------------------------------------+
void Fun_New_Bar()                         // -   
  {                                             
   New_Bar=false;                          //   
   if(New_Time!=Time[0])                   //  
     {
      New_Time=Time[0];                    //   
      New_Bar=true;                        //     
     }
  }
//+------------------------------------------------------------------+
bool Fun_Repeat(double yt,double sl,double tp ) // -    
  {
   for (int X=0; X<Repeat_Count; X++)
     {
     if (Repeat[X,0]==yt &&
         Repeat[X,1]==sl &&
         Repeat[X,2]==tp) 
       return(true);
     }
   return(false);
  }